/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/stringhandle.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_stringhandle.h"
#include "pmc_handle.h"
#include "pmc_default.h"
#include "stringhandle.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
/* LINE 1 "./src/pmc/stringhandle.pmc" */
/*
Copyright (C) 2008-2011, Parrot Foundation.

=head1 NAME

src/pmc/stringhandle.pmc - StringHandle PMC

=head1 DESCRIPTION

The StringHandle PMC performs I/O operations, but on an internal string rather
than an external file. Commonly used as a mock FileHandle for testing.

=cut

*/

#include "../src/io/io_private.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

PARROT_INLINE
static int encoding_is_utf8(PARROT_INTERP, ARGIN_NULLOK(const STRING *s))
        __attribute__nonnull__(1);

#define ASSERT_ARGS_encoding_is_utf8 __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=head2 Internal Functions

=over 4

=item C<static int encoding_is_utf8(PARROT_INTERP, const STRING *s)>

Helper function for internal usage. Return 1 if the string argument is
not null and has utf8 encoding, 0 otherwise.

=back

=cut

*/

PARROT_INLINE
static int
encoding_is_utf8(PARROT_INTERP, ARGIN_NULLOK(const STRING *s))
{
    ASSERT_ARGS(encoding_is_utf8)
    if (STRING_IS_NULL(s))
        return 0;
    else
        return STRING_equal(interp, s, CONST_STRING(interp, "utf8"));
}
/* LINE 83 "./src/pmc/stringhandle.c" */
static  PMC  * Parrot_StringHandle_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_StringHandle_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_StringHandle_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_StringHandle_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_open(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_is_closed(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_readall(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_flush(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_print(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_puts(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_buffer_type(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_buffer_size(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_mode(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_encoding(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_eof(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_StringHandle_nci_get_fd(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_StringHandle_init_orig(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_StringHandle_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_StringHandle_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_StringHandle_get_vtable(PARROT_INTERP);
void    Parrot_StringHandle_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_StringHandle_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_StringHandle_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_StringHandle_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 106 "./src/pmc/stringhandle.pmc" */

    const Parrot_StringHandle_attributes * const old_struct  = PARROT_STRINGHANDLE(_self);
    PMC * const copy = Parrot_pmc_new(interp, enum_class_StringHandle);
    Parrot_StringHandle_attributes * const data_struct = PARROT_STRINGHANDLE(copy);

    data_struct->stringhandle = old_struct->stringhandle;
    data_struct->mode     = old_struct->mode;
    data_struct->encoding = old_struct->encoding;
    data_struct->flags    = old_struct->flags;

    return copy;
/* LINE 122 "./src/pmc/stringhandle.c" */
}
static  INTVAL 
Parrot_StringHandle_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 147 "./src/pmc/stringhandle.pmc" */

    STRING *stringhandle;
    GETATTR_StringHandle_stringhandle(interp, _self, stringhandle);

    if (STRING_IS_NULL(stringhandle))
        return 0;

    return 1;
/* LINE 136 "./src/pmc/stringhandle.c" */
}
static  void 
Parrot_StringHandle_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_StringHandle_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_StringHandle_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 129 "./src/pmc/stringhandle.pmc" */

    Parrot_StringHandle_attributes * const data_struct = PARROT_STRINGHANDLE(_self);
    Parrot_gc_mark_STRING_alive(interp, data_struct->stringhandle);
    Parrot_gc_mark_STRING_alive(interp, data_struct->mode);
    Parrot_gc_mark_STRING_alive(interp, data_struct->encoding);
    Parrot_gc_mark_STRING_alive(interp, data_struct->filename);
/* LINE 154 "./src/pmc/stringhandle.c" */
}
static  void
Parrot_StringHandle_nci_open(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 164 "./src/pmc/stringhandle.pmc" */
STRING* filename;
INTVAL got_filename;
STRING* mode;
INTVAL got_mode;

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIpSoIp",
            &_self, &filename, &got_filename, &mode, &got_mode);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 176 "./src/pmc/stringhandle.pmc" */

    STRING *open_mode, *old_string;
    INTVAL flags;

    if (got_mode && !STRING_IS_NULL(mode))
        SETATTR_StringHandle_mode(interp, _self, mode);

    if (got_filename && !STRING_IS_NULL(filename))
        SETATTR_StringHandle_filename(interp, _self, filename);


    /* If StringHandle hasn't already been initialized, create a new string. */
    GETATTR_StringHandle_stringhandle(interp, _self, old_string);
    if (STRING_IS_NULL(old_string)) {
        STRING *new_string;
        STRING *encoding;

        GETATTR_StringHandle_encoding(interp, _self, encoding);
        if (encoding_is_utf8(interp, encoding))
            new_string = Parrot_str_new_init(interp, "", 0,
                    Parrot_utf8_encoding_ptr, 0);
        else
            new_string = CONST_STRING(interp, "");

        SETATTR_StringHandle_stringhandle(interp, _self, new_string);
    }

    /* Set a default mode of read-only. */
    GETATTR_StringHandle_mode(interp, _self, open_mode);
    if (STRING_IS_NULL(open_mode)) {
        open_mode = CONST_STRING(interp, "r");
        SETATTR_StringHandle_mode(interp, _self, open_mode);
    }

    flags = Parrot_io_parse_open_flags(interp, open_mode);
    SETATTR_StringHandle_flags(interp, _self, flags);

    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN PMC *_self */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *_self */
    }
/* LINE 213 "./src/pmc/stringhandle.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 233 "./src/pmc/stringhandle.c" */
}
static  void
Parrot_StringHandle_nci_is_closed(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 243 "./src/pmc/stringhandle.pmc" */

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 227 "./src/pmc/stringhandle.pmc" */

    STRING *stringhandle;
    INTVAL status;
    GETATTR_StringHandle_stringhandle(interp, _self, stringhandle);
    status = STRING_IS_NULL(stringhandle);
    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN INTVAL status */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)status);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL status */
    }
/* LINE 232 "./src/pmc/stringhandle.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 276 "./src/pmc/stringhandle.c" */
}
static  void
Parrot_StringHandle_nci_readall(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 286 "./src/pmc/stringhandle.pmc" */
STRING* name;
INTVAL got_name;

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &_self, &name, &got_name);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 247 "./src/pmc/stringhandle.pmc" */

    STRING *string_result;

    GETATTR_StringHandle_stringhandle(interp, _self, string_result);
    if (STRING_IS_NULL(string_result)) {
        STRING *encoding;
        GETATTR_StringHandle_encoding(interp, _self, encoding);
        if (encoding_is_utf8(interp, encoding))
            string_result = Parrot_str_new_init(interp, "", 0,
                    Parrot_utf8_encoding_ptr, 0);
        else
            string_result = CONST_STRING(interp, "");
    }

    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN STRING *string_result */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)string_result);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *string_result */
    }
/* LINE 261 "./src/pmc/stringhandle.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 330 "./src/pmc/stringhandle.c" */
}
static  void
Parrot_StringHandle_nci_flush(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 340 "./src/pmc/stringhandle.pmc" */

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 274 "./src/pmc/stringhandle.pmc" */

    Parrot_io_flush_handle(interp, _self);
/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 358 "./src/pmc/stringhandle.c" */
}
static  void
Parrot_StringHandle_nci_print(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 368 "./src/pmc/stringhandle.pmc" */
PMC* to_print;

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &_self, &to_print);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 289 "./src/pmc/stringhandle.pmc" */

    STRING * const string_to_print = VTABLE_get_string(interp, to_print);

    Parrot_io_putps(interp, _self, string_to_print);
/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 389 "./src/pmc/stringhandle.c" */
}
static  void
Parrot_StringHandle_nci_puts(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 399 "./src/pmc/stringhandle.pmc" */
STRING* to_print;

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &to_print);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 305 "./src/pmc/stringhandle.pmc" */

    INTVAL flags, status;
    STRING *old_string, *new_string;

    GETATTR_StringHandle_stringhandle(interp, _self, old_string);
    if (STRING_IS_NULL(old_string))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
            "Cannot write to a closed filehandle");

    GETATTR_StringHandle_flags(interp, _self, flags);
    if (!(flags & PIO_F_WRITE))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
            "Cannot write to a filehandle not opened for write");

    new_string = Parrot_str_concat(interp, old_string, to_print);

    SETATTR_StringHandle_stringhandle(interp, _self, new_string);

    status = Parrot_str_byte_length(interp, new_string);
    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN INTVAL status */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)status);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL status */
    }
/* LINE 324 "./src/pmc/stringhandle.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 447 "./src/pmc/stringhandle.c" */
}
static  void
Parrot_StringHandle_nci_buffer_type(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 457 "./src/pmc/stringhandle.pmc" */
STRING* new_type;
INTVAL got_type;

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &_self, &new_type, &got_type);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 338 "./src/pmc/stringhandle.pmc" */

    INTVAL flags;
    STRING * const nobuffer_string   = CONST_STRING(interp, "unbuffered");
    STRING * const linebuffer_string = CONST_STRING(interp, "line-buffered");
    STRING * const fullbuffer_string = CONST_STRING(interp, "full-buffered");

    GETATTR_StringHandle_flags(interp, _self, flags);

    if (got_type) {
        if (STRING_equal(interp, new_type, nobuffer_string)) {
            flags &= ~ PIO_F_LINEBUF;
            flags &= ~ PIO_F_BLKBUF;
        }
        else if (STRING_equal(interp, new_type, linebuffer_string)) {
            flags |=   PIO_F_LINEBUF;
            flags &= ~ PIO_F_BLKBUF;
        }
        else if (STRING_equal(interp, new_type, fullbuffer_string)) {
            flags &= ~ PIO_F_LINEBUF;
            flags |=   PIO_F_BLKBUF;
        }

        SETATTR_StringHandle_flags(interp, _self, flags);
    }

    if (flags & PIO_F_LINEBUF)
        /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN STRING *linebuffer_string */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)linebuffer_string);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *linebuffer_string */
    }
/* LINE 364 "./src/pmc/stringhandle.pmc" */

    else if (flags & PIO_F_BLKBUF)
        /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN STRING *fullbuffer_string */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)fullbuffer_string);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *fullbuffer_string */
    }
/* LINE 366 "./src/pmc/stringhandle.pmc" */

    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN STRING *nobuffer_string */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)nobuffer_string);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *nobuffer_string */
    }
/* LINE 367 "./src/pmc/stringhandle.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 538 "./src/pmc/stringhandle.c" */
}
static  void
Parrot_StringHandle_nci_buffer_size(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 548 "./src/pmc/stringhandle.pmc" */
INTVAL new_size;
INTVAL got_size;

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiIoIp",
            &_self, &new_size, &got_size);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 380 "./src/pmc/stringhandle.pmc" */

    INTVAL buffer_size;
    STRING *stringhandle;

    GETATTR_StringHandle_stringhandle(interp, _self, stringhandle);

    if (STRING_IS_NULL(stringhandle))
        /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN INTVAL 0 */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)0);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL 0 */
    }
/* LINE 387 "./src/pmc/stringhandle.pmc" */

    buffer_size = Parrot_str_byte_length(interp, stringhandle);

    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN INTVAL buffer_size */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)buffer_size);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL buffer_size */
    }
/* LINE 390 "./src/pmc/stringhandle.pmc" */


/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 600 "./src/pmc/stringhandle.c" */
}
static  void
Parrot_StringHandle_nci_mode(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 610 "./src/pmc/stringhandle.pmc" */

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 404 "./src/pmc/stringhandle.pmc" */

    STRING *mode;
    GETATTR_StringHandle_mode(interp, _self, mode);
    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN STRING *mode */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)mode);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *mode */
    }
/* LINE 407 "./src/pmc/stringhandle.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 641 "./src/pmc/stringhandle.c" */
}
static  void
Parrot_StringHandle_nci_encoding(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 651 "./src/pmc/stringhandle.pmc" */
STRING* new_encoding;
INTVAL got_encoding;

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &_self, &new_encoding, &got_encoding);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 421 "./src/pmc/stringhandle.pmc" */

    STRING *encoding;

    if (got_encoding) {
        SETATTR_StringHandle_encoding(interp, _self, new_encoding);
        /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN STRING *new_encoding */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)new_encoding);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *new_encoding */
    }
/* LINE 426 "./src/pmc/stringhandle.pmc" */

    }

    GETATTR_StringHandle_encoding(interp, _self, encoding);
    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN STRING *encoding */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)encoding);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *encoding */
    }
/* LINE 430 "./src/pmc/stringhandle.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 701 "./src/pmc/stringhandle.c" */
}
static  void
Parrot_StringHandle_nci_eof(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 711 "./src/pmc/stringhandle.pmc" */

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 444 "./src/pmc/stringhandle.pmc" */

    STRING *stringhandle;
    UINTVAL offset;
    GETATTR_StringHandle_stringhandle(interp, _self, stringhandle);
    GETATTR_StringHandle_read_offset(interp, _self, offset);

    if (offset >= Parrot_str_byte_length(interp, stringhandle))
        /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN INTVAL 1 */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)1);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL 1 */
    }
/* LINE 451 "./src/pmc/stringhandle.pmc" */


    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN INTVAL 0 */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)0);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL 0 */
    }
/* LINE 453 "./src/pmc/stringhandle.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 759 "./src/pmc/stringhandle.c" */
}
static  void
Parrot_StringHandle_nci_get_fd(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 364 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
/* LINE 769 "./src/pmc/stringhandle.pmc" */

/* LINE 372 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
/* LINE 376 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    { /* BEGIN PMETHOD BODY */
/* LINE 468 "./src/pmc/stringhandle.pmc" */

    UNUSED(interp);
    /* LINE 209 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    {
    /*BEGIN RETURN INTVAL -1 */
/* LINE 217 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)-1);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL -1 */
    }
/* LINE 470 "./src/pmc/stringhandle.pmc" */

/* LINE 386 "/builddir/build/BUILD/parrot-3.6.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm" */

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
/* LINE 799 "./src/pmc/stringhandle.c" */
}
static  void 
Parrot_StringHandle_init_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
/* LINE 82 "./src/pmc/stringhandle.pmc" */

    Parrot_StringHandle_attributes * const data_struct =
            (Parrot_StringHandle_attributes *) PMC_data(_self);

    data_struct->flags        = 0;
    data_struct->stringhandle = NULL;
    data_struct->mode         = NULL;
    data_struct->encoding     = NULL;
    data_struct->filename     = NULL;
    data_struct->read_offset  = 0;

    PObj_custom_mark_SET(_self);
/* LINE 817 "./src/pmc/stringhandle.c" */
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_StringHandle_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_StringHandle_clone;
    vt->get_bool = Parrot_StringHandle_get_bool;
    vt->init = Parrot_StringHandle_init;
    vt->mark = Parrot_StringHandle_mark;
    vt->attr_size = sizeof(Parrot_StringHandle_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_StringHandle_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_StringHandle_clone;
    vt->get_bool = Parrot_StringHandle_get_bool;
    vt->mark = Parrot_StringHandle_mark;
    vt->attr_size = sizeof(Parrot_StringHandle_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_StringHandle_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_get_vtable(interp);
    Parrot_StringHandle_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_StringHandle_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_ro_get_vtable(interp);
    Parrot_StringHandle_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_StringHandle_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Handle_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        Parrot_str_new_init(interp, "StringHandle", 12,
            Parrot_default_encoding_ptr, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_StringHandle_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_Handle_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "StringHandle")), PMCNULL);
    return isa;
}

void
Parrot_StringHandle_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":os_handle Irecord_separator Iflags Sstringhandle Smode Sencoding Sfilename Iread_offset ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_StringHandle_get_vtable(interp);
        vt->base_type      = enum_class_StringHandle;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "StringHandle");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_StringHandle_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_StringHandle_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_StringHandle;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_StringHandle_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "open");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_open),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "is_closed");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_is_closed),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "readall");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_readall),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "flush");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_flush),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "print");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_print),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "puts");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_puts),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "buffer_type");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_buffer_type),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "buffer_size");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_buffer_size),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "mode");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_mode),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "encoding");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_encoding),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "eof");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_eof),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get_fd");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_StringHandle_nci_get_fd),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_StringHandle_class_init */
/* LINE 481 "./src/pmc/stringhandle.pmc" */
 /* end pmclass */

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
